.button {
  position: relative;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  cursor: pointer;
  border-radius: var(--btn-border-radius);
  font-family: var(--font-primary);

  border: var(--btn-border-width);
  overflow: hidden;
  width: fit-content;
  white-space: nowrap;

  &.primary {
    background-color: var(--btn1-bg-color);
    color: var(--btn1-text-color);
    border: var(--btn-border-width) solid var(--btn1-border-color);
    padding: var(--btn-padding-y) var(--btn-padding-x);
  }

  &.primary:hover {
    color: var(--btn1-hover-text-color);
    background-color: var(--btn1-hover-bg-color);
  }

  &.secondary {
    background-color: var(--btn2-bg-color);
    color: var(--btn2-text-color);
    border: var(--btn-border-width) solid var(--btn2-border-color);
    padding: var(--btn-padding-y) var(--btn-padding-x);
  }

  &.secondary:hover {
    color: var(--btn2-hover-text-color);
    background-color: var(--btn2-hover-bg-color);
  }

  &.circle-button {
    @apply md:w-[71px] md:h-[71px] w-[41px] h-[41px] p-0;
  }
}

// EFFECT : fade
.button.effect-fade {
  transition: background-color 0.3s ease-out !important;
}

// EFFECT : expandRight
.button.effect-expandRight {
  ///undo the 'none' bg effect
  &.primary:hover {
    background-color: var(--btn1-bg-color);
  }
  &.secondary:hover {
    background-color: var(--btn2-bg-color);
  }

  &::before {
    content: "";
    position: absolute;
    left: 0;
    width: 20px;
    transform: translateX(-50%);
    aspect-ratio: 1/1;
    opacity: 0;
    transition: width 0.3s ease-out, opacity 0.3s ease-out !important;
    border-radius: var(--btn-border-radius);
  }

  &:hover::before {
    width: 200%;
    opacity: 1;
    transform: translateX(-50%);
    transition: width 0.3s ease-out, opacity 0.3s ease-out !important;
  }

  &.primary::before {
    background-color: var(--btn1-hover-bg-color);
  }

  &.secondary::before {
    background-color: var(--btn2-hover-bg-color);
  }

  &.active::before {
    width: 200%;
    opacity: 1;
  }
}

// EFFECT : grow
.button.effect-grow {
  transform: scale(1);
  transition: transform 0.3s ease-out !important;
  &:hover {
    transform: scale(1.1);
  }
}
